﻿using Contracts.BindingModels;
using Contracts.ViewModels;
using DataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace DateBaseImplement.Models
{
    public class Type : ITypeModel
    {
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }

        public static Type? Create(TypeBindingModel model)
        {
            if (model == null) return null;

            return new Type()
            {
                Name = model.Name,
            };
        }

        public void Update(TypeBindingModel model)
        {
            if (model == null) return;
            model.Name = Name;
        }

        public TypeViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name,
        };
    }
}
